##Secdissolve_v3c=name
##Shape_original=vector polygon

from qgis.core import *
from qgis.utils import *
from PyQt4.QtGui import *
from PyQt4.QtCore import QFile, QFileInfo
from PyQt4.QtCore import QVariant
import os
from PyQt4.QtCore import *
from processing.tools.vector import VectorWriter
from shapely.geometry import Polygon, MultiPolygon
from shapely.wkb import loads
from shapely.wkt import dumps

# Verificar se a layer escolhida eh uma layer em memoria:
lyr0 = processing.getObject(Shape_original)
if str(lyr0.providerType())=="memory":
    QMessageBox.information(None, "Nota importante:","A layer escolhida para corrigir encontra-se apenas em memoria. Grave esta layer no disco rigido do seu PC e volte a correr este script com a layer gravada em disco." )
elif lyr0.featureCount()==1:
    QMessageBox.information(None, "Nota importante:","A layer escolhida para corrigir possui apenas um elemento (feature), pelo que nao se aplica este script." )

else:    
    progress.setPercentage(10)
    progress.setText("A preparar duplicado da shape inicial...")
    time.sleep(2)
    # Eliminar Multiparts na shape original
    outputs_QGISMULTIPARTTOSINGLEPARTS_1=processing.runalg('qgis:multiparttosingleparts', lyr0,None,progress=None)

    # Duplicar o Shape_original e colocar em memoria
    lyr1 = processing.getObject(outputs_QGISMULTIPARTTOSINGLEPARTS_1['OUTPUT'])
    lyr1CRS = lyr1.crs().authid()
    theActiveLayer=iface.setActiveLayer(lyr1)
    thefileName = lyr0.source()
    fileInfo = QFileInfo(thefileName)
    thebaseName = fileInfo.baseName()
    flnm= os.path.dirname( unicode( iface.activeLayer().dataProvider().dataSourceUri() ) ) 

    feats = [feat for feat in lyr1.getFeatures()]
    mem_layer = QgsVectorLayer("MultiPolygon?crs="+str(lyr1CRS), "Duplicado", "memory")
    mem_layer_data = mem_layer.dataProvider()
    attr = lyr1.dataProvider().fields().toList()
    mem_layer_data.addAttributes(attr)
    mem_layer.updateFields()
    mem_layer_data.addFeatures(feats)
    QgsMapLayerRegistry.instance().addMapLayer(mem_layer)   
    progress.setPercentage(20)
    progress.setText("A preparar campos do duplicado...")
    time.sleep(2)

    # Eliminar campos ID existentes

    field_ids = []
    fieldnames = set(['ID','Id','id','iD'])
    for field in mem_layer.fields():
        if field.name() in fieldnames:
          field_ids.append(mem_layer.fieldNameIndex(field.name()))

    mem_layer.dataProvider().deleteAttributes(field_ids)
    mem_layer.updateFields()

    # Vai ser preciso construir um novo campo ID para processar o algoritmo saga:polygonselfintersection

    mem_layer.startEditing()
    mem_layer.dataProvider().addAttributes([QgsField("ID",  QVariant.Int)])
    mem_layer.updateFields()

    idx=mem_layer.fieldNameIndex('ID')
    e=QgsExpression('$id')                      # Esta eh a melhor formar de construir um campo Id sequencial!
    e.prepare(mem_layer.pendingFields())
    for f in mem_layer.getFeatures():
        f[idx]=e.evaluate(f)
        mem_layer.updateFeature(f)

    mem_layer.updateFields()
    mem_layer.commitChanges()
    id = "ID"  # Esta variavel vai ser usada no algoritmo saga:polygonselfintersection
    progress.setPercentage(30)
    progress.setText("A auto-intersectar duplicado...")
    time.sleep(2)

    # Processar a auto-interseccao

    intersect_res=processing.runalg('saga:polygonselfintersection', mem_layer, id, None,progress=None)
    Intersected_layer =  processing.getObject(intersect_res['INTERSECT'])

    # Acrescentar o campo 'Control' na layer Intersection
    Intersected_layer.startEditing()
    Intersected_layer.dataProvider().addAttributes([QgsField("Control",  QVariant.Int)])
    Intersected_layer.updateFields()

    idx=Intersected_layer.fieldNameIndex('Control')
    e=QgsExpression('$id+1000000')
    e.prepare(Intersected_layer.pendingFields())
    for f in Intersected_layer.getFeatures():
        f[idx]=e.evaluate(f)
        Intersected_layer.updateFeature(f)

    Intersected_layer.commitChanges()
    progress.setPercentage(35)
    progress.setText("A preparar campo de controlo. Este passo pode ser (muito) demorado!")
    time.sleep(2)

    Intersected_layer.selectAll()
    count = Intersected_layer.selectedFeatureCount()
    Intersected_layer.removeSelection()
    j=0
    i = 0
    Intersected_layer.startEditing()
    for feature in Intersected_layer.getFeatures():
        idx = Intersected_layer.fieldNameIndex('ID_1')
        value_count = feature.attributes()[idx].count('|')
        att_value = feature.attributes()[idx]
        
        if value_count > 0:
            i = i+1
            ID_value1 = att_value.partition('|') [0]   
            for feat in Intersected_layer.getFeatures():
                idx1 = Intersected_layer.fieldNameIndex('ID_1')
                if feat.attributes()[idx1] == str(ID_value1):
                    feat['Control'] = i
                    Intersected_layer.updateFeature(feat)
                elif feat.attributes()[idx1].partition('|') [0] == str(ID_value1):
                    feat['Control'] = i
                    Intersected_layer.updateFeature(feat)
            j = j + 1
            percent = ((j/float(count)) * 100)+40
            if percent < 97:
                progress.setPercentage(percent)
            else:
                progress.setPercentage(97)

    Intersected_layer.commitChanges()
    
    # Executar o dissolve das arestas comuns dos elementos (poligonos) que tenham o mesmo valor no campo 'Control'
    progress.setText("A dissolver elementos sobrepostos...")
    progress.setPercentage(98)
    
    outputs_QGISREMOVENULLGEOMETRIES_1=processing.runalg('qgis:removenullgeometries', Intersected_layer,None,progress=None)

    outputs_SAGAPOLYGONDISSOLVEBYATTRIBUTE_1=processing.runalg('saga:polygondissolvebyattribute', outputs_QGISREMOVENULLGEOMETRIES_1['OUTPUT_LAYER'],"Control",None,None,False,None,progress=None)

    remove_res=processing.runalg('qgis:removenullgeometries', outputs_SAGAPOLYGONDISSOLVEBYATTRIBUTE_1['DISSOLVED'],None,progress=None)
    Intersected_layer1 =  processing.getObject(remove_res['OUTPUT_LAYER'])

    # Recalcular areas
    Intersected_layer1.startEditing()
    Intersected_layer1.dataProvider().addAttributes([QgsField("Area_dsv",   QVariant.Double, "double", 12, 2)])
    Intersected_layer1.updateFields()

    idx2=Intersected_layer1.fieldNameIndex('Area_dsv')
    e=QgsExpression('$area')
    e.prepare(Intersected_layer1.pendingFields())
    for f in Intersected_layer1.getFeatures():
        f[idx2]=e.evaluate(f)
        Intersected_layer1.updateFeature(f)
    #
    Intersected_layer1.commitChanges()

    with edit(Intersected_layer1):
        request = QgsFeatureRequest().setFilterExpression('"Area_dsv" < 0.01') 
        request.setSubsetOfAttributes([])
        request.setFlags(QgsFeatureRequest.NoGeometry)
        for f in Intersected_layer1.getFeatures(request):
            Intersected_layer1.deleteFeature(f.id())
    Intersected_layer1.commitChanges()
    progress.setPercentage(99)
    time.sleep(2)
    
    while len(QgsMapLayerRegistry.instance().mapLayersByName('Duplicado')) > 0:
       layer5 = QgsMapLayerRegistry.instance().mapLayersByName('Duplicado')[0]
       QgsMapLayerRegistry.instance().removeMapLayer(layer5.id())
    #

    # Fim da execucao da primeira parte do script
    progress.setPercentage(100)
    progress.setText("A eliminar slivers e small holes...")

    # Calcular area do elemento mais pequeno
    Min_area = Intersected_layer1.minimumValue(idx2)

    # Limpar o resultado (eliminar pequenos buracos)

    while len(QgsMapLayerRegistry.instance().mapLayersByName(thebaseName+"_corrigido")) > 0:
       layer5 = QgsMapLayerRegistry.instance().mapLayersByName(thebaseName+"_corrigido")[0]
       QgsMapLayerRegistry.instance().removeMapLayer(layer5.id())

    Max_Area=Min_area-(Min_area*0.1)
    if Max_Area > 1:
        Max_Area = 1.01
    
    Delete_holes=True
    polyPrder = Intersected_layer1.dataProvider()
    n = Intersected_layer1.featureCount()
    l = 0

    writer = VectorWriter(flnm+"/"+thebaseName+"_corrigido.shp", None, polyPrder.fields(),
                          QGis.WKBMultiPolygon, polyPrder.crs())
                          

    for feat in processing.features(Intersected_layer1):
        progress.setPercentage(int(100*l/n))
        l+=1
        
        geom = loads(feat.geometry().asWkb())
        resgeom = []
        
        if geom.geom_type == 'Polygon': geom = [geom]
            
        for g in geom:
                            
            if Polygon(g.exterior).area > Max_Area:			# esta area sempre maior que o menor poligono
                            
                if not Delete_holes or len(g.interiors) == 0:
                    resgeom.append(g)
                else:
                    h = [h for h in g.interiors if Polygon(h).area > Max_Area]
                    resgeom.append(Polygon(g.exterior,h))
        
        if len(resgeom) > 0:
            feat.setGeometry(QgsGeometry.fromWkt(dumps(MultiPolygon(resgeom))))
            writer.addFeature(feat)		

    del writer

    # Colocar a layer corrigida na TOC

    iface.addVectorLayer(flnm+"/"+thebaseName+"_corrigido.shp", thebaseName+"_corrigido", "ogr")

QMessageBox.information(None, "Nota", "Fim do script.")  
#Sobral Almeida, Abril/2020